import java.util.Collection;

import javax.persistence.EntityManager;
import javax.persistence.Query;

public class ProfessorService {
  protected EntityManager em;

  public ProfessorService(EntityManager em) {
    this.em = em;
  }

  public Professor createProfessor(int id, String name, long salary) {
    Professor emp = new Professor();
    emp.setId(id);
    emp.setName(name);
    emp.setSalary(salary);
    em.persist(emp);

    return emp;
  }

  public Collection<Professor> findAllProfessors() {
    Query query = em.createQuery("SELECT e FROM Professor e");
    return (Collection<Professor>) query.getResultList();
  }

  public ParkingSpace createParkingSpace(Professor emp, int lot, String location) {
    ParkingSpace space = new ParkingSpace();
    space.setId(emp.getId());
    space.setLot(lot);
    space.setLocation(location);

    emp.setParkingSpace(space);
    space.setProfessor(emp);
    em.persist(space);

    return space;
  }

  public Collection<ParkingSpace> findAllParkingSpaces() {
    Query query = em.createQuery("SELECT p FROM ParkingSpace p");
    return (Collection<ParkingSpace>) query.getResultList();
  }
}
